<template>
  <v-dialog
    width="50%"
    height="auto"
    v-model="selectedValue"
    name="edit_client_receipt"
  >
    <v-card>
      <v-card-title class="light">Modifiko një mandat</v-card-title>
      <v-container>
        <v-row class="mx-2">
          <v-col cols="12">
            <v-select
              label="Arka / Banka *"
              v-model="request.cash_unit_id"
              :items="banks"
              item-text="unit_name"
              item-value="id"
              :readonly="readonly"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col class="align-center justify-space-between" cols="6">
            <v-select
              label="Lloji"
              v-model="request.document_type"
              :items="documentTypes"
              :readonly="readonly"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col class="align-center justify-space-between" cols="6">
            <v-text-field
              label="Data*"
              type="date"
              v-model="request.date"
              :readonly="readonly"
            />
          </v-col>
          <v-col class="align-center justify-space-between" cols="6">
            <v-text-field
              label="Vlera*"
              v-model="request.value"
              type="number"
              min="0"
              :readonly="readonly"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col class="align-center justify-space-between" cols="6">
            <v-select
              label="Monedha"
              v-model="request.currency_id"
              :items="currencies"
              item-value="id"
              item-text="currency"
              @change="getExchangeRate"
              :readonly="readonly"
            />
          </v-col>
          <v-col class="align-center justify-space-between" cols="6">
            <v-text-field
              label="Kursi"
              v-model="request.exchange_rate"
              :readonly="readonly"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col class="align-center justify-space-between" cols="6">
            <v-text-field
              label="Shënime*"
              v-model="request.notes"
              :readonly="readonly"
            />
          </v-col>
        </v-row>
      </v-container>
      <v-card-actions>
        <f-confirm-btn
          label="Konfirmo kredit"
          @click="confirm"
          :disabled="loading"
          v-if="!readonly()"
        />
        <p class="confirmed" v-if="readonly()">
          Mandat i konfirmuar
        </p>
        <v-spacer />
        <f-cancel-btn @click="close" v-if="!readonly()" />
        <f-submit-btn
          @click="submit"
          :loading="loading"
          :disabled="loading"
          v-if="!readonly()"
        />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<script lang="ts">
import Vue from 'vue'
import { Component, Prop } from 'vue-property-decorator'
import api from '../../../../plugins/api'
import eventBus from '../../../../plugins/event-bus'
import FSubmitBtn from '../../../../components/buttons/FSubmitBtn.vue'
import FCancelBtn from '../../../../components/buttons/FCancelBtn.vue'
import FConfirmBtn from '../../../../components/buttons/FConfirmBtn.vue'

@Component({
  components: { FSubmitBtn, FCancelBtn, FConfirmBtn },
})
export default class EditClientReceipt extends Vue {
  @Prop({ required: true }) value
  @Prop({ type: Object }) receipt
  request = {
    creditable_id: this.$route.params.id,
    creditable_type: 'App\\Client',
    document_type: '',
    date: '',
    value: '',
    currency_id: '',
    exchange_rate: '',
    notes: '',
    cash_unit_id: '',
    status_id: 0,
  }
  loading = false
  currencies = []
  banks = []
  documentTypes = ['MA', 'MAB', 'MAC']
  mounted() {
    this.fetchCurrencies()
    this.fetchReceipt()
    this.fetchBanks()
  }
  get selectedValue() {
    return this.value
  }
  set selectedValue(newValue) {
    this.$emit('input', newValue)
  }
  fetchBanks() {
    api()
      .get('/api/account-management/banks')
      .then(response => {
        this.banks = response.data.data
      })
      .finally(() => (this.loading = false))
  }

  close() {
    this.selectedValue = false
    this.request.document_type = ''
    this.request.date = ''
    this.request.value = ''
    this.request.currency_id = ''
    this.request.exchange_rate = ''
    this.request.notes = ''
    this.request.cash_unit_id = ''
  }
  fetchCurrencies() {
    api()
      .get('api/sales-management/checkout-info')
      .then(response => {
        this.currencies = response.data.data.currencies
      })
  }
  getExchangeRate() {
    this.request.exchange_rate = this.currencies.find(
      currency => currency.id === this.request.currency_id
    ).official_sell_rate
  }
  fetchReceipt() {
    api()
      .get(`api/account-management/receipts/${this.receipt.id}`)
      .then(response => {
        this.request = response.data.data[0]
      })
  }
  submit() {
    this.loading = true
    api()
      .put(`api/account-management/receipts/${this.receipt.id}`, this.request)
      .then(response => {
        alert(response.data.message)
        if (!(response && response.data && response.data.status === 0)) return
        this.selectedValue = false
        eventBus.$emit('refresh')
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }
  confirm() {
    api()
      .put(
        `api/account-management/receipts/${this.receipt.id}/confirm`,
        this.request
      )
      .then(response => {
        alert(response.data.message)
        if (!(response && response.data && response.data.status === 0)) return
        this.close()
        eventBus.$emit('refresh')
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }

  readonly() {
    return this.request.status_id === 16 || this.request.status_id === 1
  }
}
</script>

<style scoped>
.confirmed {
  font-size: 1.2rem;
  color: #25d61b;
  padding-left: 1.5rem;
}
</style>
